#ifndef __LRGTOFACONVERTER_H__
#define __LRGTOFACONVERTER_H__

#include <grammar/Regular/LeftRegularGrammar.h>
#include <automaton/FSM/FSM.h>

#include "../../interface/IConversionFSM.h"

namespace conversions
{

/**
 * Converts left regular grammar to finite automata.
 * Source: Melichar 2.102.
 */
class LRGtoFAConverter : public IConversionFSM
{
public:
    /**
     * @param grammar Source left regular grammar.
     */
    LRGtoFAConverter( const grammar::LeftRegularGrammar & grammar );

    ~LRGtoFAConverter( void );

    /**
     * Performs conversion.
     * @return FSM equivalent to source grammar.
     */
    automaton::FSM convert( void );

private:
    /**
     * input grammar
     */
    const grammar::LeftRegularGrammar & m_grammar;
};

} /* namespace conversions */

#endif /* __LRGTOFACONVERTER_H__ */
