/*
 * GlushkovSymbol.cpp
 *
 *  Created on: 14. 4. 2014
 *      Author: tomas
 */

#include "GlushkovSymbol.h"

using namespace alphabet;
using namespace regexp;

namespace conversions
{

GlushkovSymbol::GlushkovSymbol( RegExpSymbol const * const & node, int i ) :
        m_regexpSymbol( node ), m_i( i )
{

}

bool GlushkovSymbol::operator<( GlushkovSymbol const& x ) const
{
    return m_i < x.m_i;
}

int GlushkovSymbol::getId( void ) const
{
    return m_i;
}

Symbol GlushkovSymbol::getInputSymbol( void ) const
{
    return Symbol( m_regexpSymbol->getSymbol( ) );
}

RegExpSymbol const * const GlushkovSymbol::getSymbolPtr( void ) const
{
    return m_regexpSymbol;
}

} /* namespace conversions */
