#include <iostream>

#include <AlibException.h>
#include <regexp/RegExp.h>
#include <regexp/RegExpParser.h>
#include <regexp/RegExpSymbol.h>
#include <sax/SaxInterface.h>

#include "RegExpDerivation.h"


using namespace alib;
using namespace regexp;
using namespace std;

/*
 * Usage:
 *  aderivative "a" "b" "cc" < regexp.xml
 */

int main(int argc, char** argv)
{
    try
    {
        list<Token> tokens;
        string input(istreambuf_iterator<char>(cin), (istreambuf_iterator<char>()));
        SaxInterface::parseMemory(input, tokens);
        RegExp re = RegExpParser::parse(tokens);

        list<Symbol> dString;
        for( int i = 1; i < argc ; i++ )
        {
            string symbol( argv[ i ] );
            // cout << "'" << symbol << "'" << endl;
            dString.push_back( Symbol( symbol ) );
        }
        RegExpDerivation d( re );
        d.derivation( dString ).toXML( cout );
    }
    catch( AlibException & e )
    {
        cout << e.what() << endl;
        return 1;
    }

    return 0;
}
