/*
 * AlibException.h
 *
 *  Created on: Apr 1, 2013
 *      Author: martin
 */

#ifndef ALIBEXCEPTION_H_
#define ALIBEXCEPTION_H_

#include <exception>
#include <string>

namespace alib {

using namespace std;

/**
 * Basic exception from which are derived all other exceptions.
 * Contains reason why the exception occured.
 */
class AlibException: public exception {
protected:
	string cause;
public:
	AlibException();
	AlibException(const string& cause);
	virtual ~AlibException() throw ();

	/**
	 * @return reason why the exception occured
	 */
	const char* what() const throw ();

	/**
	 * @return reason why the exception occured
	 */
	const std::string& getCause() const;
};

} /* namespace alib */
#endif /* ALIBEXCEPTION_H_ */
