/*
 * TransitionTM.cpp
 *
 *  Created on: Apr 24, 2013
 *      Author: martin
 */

#include "TransitionTM.h"

namespace automaton {

TransitionTM::TransitionTM(const State& from, const Symbol& input, const State& to, const Symbol& output,
		Shift shift) :
		Transition(from, input, to), output(output), shift(shift) {
}

const Symbol& TransitionTM::getOutput() const {
	return output;
}
void TransitionTM::setOutput(const Symbol& output) {
	this->output = output;
}
Shift TransitionTM::getShift() const {
	return shift;
}
void TransitionTM::setShift(Shift shift) {
	this->shift = shift;
}

bool TransitionTM::operator <(const TransitionTM& other) const {
	if (from != other.from) {
		return from < other.from;
	} else if (input != other.input) {
		return input < other.input;
	} else if (to != to) {
		return to < other.to;
	} else if (output != output) {
		return output < other.output;
	} else {
		return shift < other.shift;
	}

}
bool TransitionTM::operator ==(const TransitionTM& other) const {
	return from == other.from && input == other.input && to == other.to && output == other.output
			&& shift == other.shift;
}
bool TransitionTM::operator !=(const TransitionTM& other) const {
	return !((*this) == other);
}

std::ostream& TransitionTM::operator>>(std::ostream& out) const {
	out << "TransitionTM from = " << this->from
		<< " to = " << this->to
		<< " input = " << this->input
		<< " output = " << this->output
		<< " shift = " << SHIFT_NAMES[this->shift];

	return out;
}

} /* namespace automaton */
