/*
 * UnrestrictedGrammar.cpp
 *
 *  Created on: Nov 17, 2013
 *      Author: martin
 */

#include "UnrestrictedGrammar.h"

namespace grammar {

UnrestrictedGrammar::UnrestrictedGrammar() :
		Grammar() {
}

UnrestrictedGrammar::UnrestrictedGrammar(const set<Symbol>& nonTerminalSymbols, const set<Symbol>& terminalSymbols,
		const Symbol& startSymbol) :
		Grammar(nonTerminalSymbols, terminalSymbols, startSymbol) {
}

bool UnrestrictedGrammar::isValidRule(const Rule& rule) const {
	if (rule.getLeftSide().size() == 0) {
		return false;
	}

	for (auto const & symbol : rule.getLeftSide()) {
		if (terminalSymbols.find(symbol) == terminalSymbols.end()
				&& nonTerminalSymbols.find(symbol) == nonTerminalSymbols.end()) {
			return false;
		}
	}

	for (auto const & right : rule.getRightSide()) {
		if (terminalSymbols.find(right) == terminalSymbols.end()
				&& nonTerminalSymbols.find(right) == nonTerminalSymbols.end()) {
			return false;
		}
	}

	return true;
}

} /* namespace grammar */
