/*
 * StringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_PARSER_H_
#define STRING_PARSER_H_

#include <list>

#include "String.h"
#include "../sax/Token.h"

namespace notions {
namespace string {

/**
 * Parser used to get String from XML parsed into list of tokens.
 */
class StringParser {
protected:
	static void parseContent(std::list<sax::Token>& input, String& content);
	static void parseAlphabet(std::list<sax::Token>& input, String& alphabet);

	static bool isToken(std::list<sax::Token> &input, sax::Token::TokenType type, std::string data);
	static void popToken(std::list<sax::Token> &input, sax::Token::TokenType type, std::string data);

public:
	/**
	 * Parses the XML and returns regular expression. The input is destroyed in the process.
	 * @param input XML represented as list of tokens
	 * @return String
	 * @throws ParserException when an error occurs
	 */
	static String parse(std::list<sax::Token>& input);
};

} /* namespace string */
} /* namespace notions */
#endif /* STRING_PARSER_H_ */
