/*
 * StringPrinter.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef STRING_PRINTER_H_
#define STRING_PRINTER_H_

#include <ostream>
#include "String.h"

namespace notions {
namespace string {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class StringPrinter {
protected:
	static const std::string INDENTATION;

	static void printContent(const String& element, std::ostream& out, const std::string & prefix);
	static void printAlphabet(const String& content, std::ostream& out, const std::string & prefix);
	static void printSymbol(const alphabet::Symbol& symbol, std::ostream& out, const std::string & prefix);
public:
	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	static void toXML(const notions::string::String& regexp, std::ostream& out);
};

} /* namespace string */
} /* namespace notions */
#endif /* STRING_PRINTER_H_ */
