/*
 * FromXMLParsers.cpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#include "FromXMLParser.hpp"
#include "FromXMLParsers.h"

namespace alib {

// NOTE: do not remove this explicit specialisation of parseValue for Exceptions unless you refactor ExceptionFromXMLParser. The implicit specialisation causes inifite recursion
template<>
exception::AlibException FromXMLParser<exception::AlibException, exception::FEATURES>::parseValue(std::list<sax::Token>& input) const {
	exception::AlibException res = parse(input);

	if(input.size() == 0) {
		return res;
	} else {
		throw exception::AlibException();
	}
}

void tryParseAndThrowException(std::list<sax::Token>& input) {
	if(FromXMLParsers::exceptionParser.first(input)) {
		throw FromXMLParsers::exceptionParser.parseValue(input);
	}
}

} /* namespace alib */
