/*
 * BlankSymbol.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef BLANK_SYMBOL_H_
#define BLANK_SYMBOL_H_

#include "Symbol.h"

namespace alphabet {

/**
 * Represents blank symbol in an alphabet.
 */
class BlankSymbol : public std::element<BlankSymbol, SymbolBase> {
public:
	/**
	 * Creates a blank symbol.
	 * @param symbol name of the symbol
	 */
	BlankSymbol();

	virtual SymbolBase* clone() const;
	virtual SymbolBase* plunder() &&;
	
	virtual bool operator <(const SymbolBase& other) const;
	virtual bool operator ==(const SymbolBase& other) const;
	virtual bool operator >(const SymbolBase& other) const;

	virtual bool operator ==(const BlankSymbol& other) const;
	virtual bool operator <(const BlankSymbol& other) const;

	virtual void operator>>(std::ostream& out) const;
	
	virtual operator std::string () const;

	static BlankSymbol BLANK;
};

} /* namespace alphabet */

#endif /* BLANK_SYMBOL_H_ */
