/*
 * BottomOfTheStackSymbol.cpp
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#include "BottomOfTheStackSymbol.h"

namespace alphabet {

BottomOfTheStackSymbol::BottomOfTheStackSymbol() {

}

SymbolBase* BottomOfTheStackSymbol::clone() const {
	return new BottomOfTheStackSymbol(*this);
}

SymbolBase* BottomOfTheStackSymbol::plunder() && {
	return new BottomOfTheStackSymbol(std::move(*this));
}

bool BottomOfTheStackSymbol::operator <(const SymbolBase& other) const {
	return other > *this;
}

bool BottomOfTheStackSymbol::operator ==(const SymbolBase& other) const {
	return other == *this;
}

bool BottomOfTheStackSymbol::operator >(const SymbolBase& other) const {
	return other < *this;
}

bool BottomOfTheStackSymbol::operator ==(const BottomOfTheStackSymbol&) const {
	return true;
}

bool BottomOfTheStackSymbol::operator <(const BottomOfTheStackSymbol&) const {
	return false;
}

void BottomOfTheStackSymbol::operator>>(std::ostream& out) const {
	out << "(Blank symbol)";
}

BottomOfTheStackSymbol::operator std::string () const {
	return "";
}

BottomOfTheStackSymbol BottomOfTheStackSymbol::BOTTOM_OF_THE_STACK = BottomOfTheStackSymbol();

} /* namespace alphabet */
