/*
 * BottomOfTheStackSymbol.h
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#ifndef BOTTOM_OF_THE_STACK_SYMBOL_H_
#define BOTTOM_OF_THE_STACK_SYMBOL_H_

#include "Symbol.h"

namespace alphabet {

/**
 * Represents blank symbol in an alphabet.
 */
class BottomOfTheStackSymbol : public std::element<BottomOfTheStackSymbol, SymbolBase> {
public:
	/**
	 * Creates a blank symbol.
	 * @param symbol name of the symbol
	 */
	BottomOfTheStackSymbol();

	virtual SymbolBase* clone() const;
	virtual SymbolBase* plunder() &&;
	
	virtual bool operator <(const SymbolBase& other) const;
	virtual bool operator ==(const SymbolBase& other) const;
	virtual bool operator >(const SymbolBase& other) const;

	virtual bool operator ==(const BottomOfTheStackSymbol& other) const;
	virtual bool operator <(const BottomOfTheStackSymbol& other) const;

	virtual void operator>>(std::ostream& out) const;
	
	virtual operator std::string () const;

	static BottomOfTheStackSymbol BOTTOM_OF_THE_STACK;
};

} /* namespace alphabet */

#endif /* BOTTOM_OF_THE_STACK_SYMBOL_H_ */
