/*
 * EndSymbol.h
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#ifndef END_SYMBOL_H_
#define END_SYMBOL_H_

#include "Symbol.h"

namespace alphabet {

/**
 * Represents blank symbol in an alphabet.
 */
class EndSymbol : public std::element<EndSymbol, SymbolBase> {
public:
	/**
	 * Creates a blank symbol.
	 * @param symbol name of the symbol
	 */
	EndSymbol();

	virtual SymbolBase* clone() const;
	virtual SymbolBase* plunder() &&;
	
	virtual bool operator <(const SymbolBase& other) const;
	virtual bool operator ==(const SymbolBase& other) const;
	virtual bool operator >(const SymbolBase& other) const;

	virtual bool operator ==(const EndSymbol& other) const;
	virtual bool operator <(const EndSymbol& other) const;

	virtual void operator>>(std::ostream& out) const;
	
	virtual operator std::string () const;

	static EndSymbol END;
};

} /* namespace alphabet */

#endif /* END_SYMBOL_H_ */
