/*
 * SymbolBase.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "SymbolBase.h"
#include <typeinfo>

#include "LabeledSymbol.h"
#include "BlankSymbol.h"
#include "BottomOfTheStackSymbol.h"
#include "EndSymbol.h"

namespace alphabet {

SymbolBase::~SymbolBase() noexcept {

}

bool SymbolBase::operator !=(const SymbolBase& other) const {
	return !(*this == other);
}

std::ostream& operator<<(std::ostream& out, const SymbolBase& symbol) {
	symbol >> out;
	return out;
}

bool SymbolBase::operator==(const LabeledSymbol&) const {
	return false;
}

bool SymbolBase::operator==(const BlankSymbol&) const {
	return false;
}

bool SymbolBase::operator==(const BottomOfTheStackSymbol&) const {
	return false;
}

bool SymbolBase::operator==(const EndSymbol&) const {
	return false;
}

bool SymbolBase::operator<(const LabeledSymbol& other) const {
	return typeid(*this).before(typeid(other));
}

bool SymbolBase::operator<(const BlankSymbol& other) const {
	return typeid(*this).before(typeid(other));
}

bool SymbolBase::operator<(const BottomOfTheStackSymbol& other) const {
	return typeid(*this).before(typeid(other));
}

bool SymbolBase::operator<(const EndSymbol& other) const {
	return typeid(*this).before(typeid(other));
}

} /* namespace alphabet */
