/*
 * SymbolFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef SYMBOL_FROM_STRING_PARSER_H_
#define SYMBOL_FROM_STRING_PARSER_H_

#include "Symbol.h"
#include <vector>

#include "SymbolFromStringLexer.h"
#include "../label/LabelFromStringParser.h"
#include "SymbolFeatures.h"
#include "../FromStringParser.hpp"

namespace string {

class StringFromStringParser;

} /* namespace alphabet */

namespace regexp {

class RegExpFromStringParser;

} /* namespace regexp */

namespace automaton {

class FiniteAutomatonFromStringParser;

} /* namespace automaton */

namespace alphabet {

class SymbolFromStringParser : public alib::FromStringParser<Symbol, FEATURES> {
	LabeledSymbol parseContent();
	
	SymbolFromStringLexer m_SymbolLexer;
	label::LabelFromStringParser m_LabelParser;
	virtual Symbol parse();
	virtual Symbol parse(const std::set<FEATURES>& features);
	bool next();
	virtual bool last();
public:
	virtual bool first();
	SymbolFromStringParser(std::stringstream&);
	friend class string::StringFromStringParser;
	friend class regexp::RegExpFromStringParser;
	friend class automaton::FiniteAutomatonFromStringParser;
};

} /* namespace alphabet */

#endif /* SYMBOL_FROM_STRING_PARSER_H_ */
