/*
 * SymbolToStringComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "SymbolToStringComposer.h"
#include "../label/LabelToStringComposer.h"
#include <algorithm>
#include "LabeledSymbol.h"

namespace alphabet {

void SymbolToStringComposer::Visit(void* userData, const LabeledSymbol& symbol) {
	std::stringstream &out = *((std::stringstream*) userData);

	label::LabelToStringComposer composer;
	out << composer.compose(symbol.getLabel());
}

void SymbolToStringComposer::Visit(void* userData, const BlankSymbol&) {
	std::stringstream &out = *((std::stringstream*) userData);

	out << "#B";
}

void SymbolToStringComposer::Visit(void* userData, const BottomOfTheStackSymbol&) {
	std::stringstream &out = *((std::stringstream*) userData);

	out << "#Z";
}

void SymbolToStringComposer::Visit(void* userData, const EndSymbol&) {
	std::stringstream &out = *((std::stringstream*) userData);

	out << "#E";
}

void SymbolToStringComposer::Visit(void* userData, const Symbol& symbol) {
	symbol.getSymbol().Accept(userData, *this);

}

std::string SymbolToStringComposer::compose(const Symbol& symbol) {
	std::stringstream out;
	Visit((void*) &out, symbol);
	return std::move(out).str();
}

} /* namespace alphabet */
