/*
 * SymbolToStringComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef SYMBOL_TO_STRING_COMPOSER_H_
#define SYMBOL_TO_STRING_COMPOSER_H_

#include <sstream>
#include "Symbol.h"
#include "../sax/Token.h"
#include "../label/Label.h"

namespace alphabet {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class SymbolToStringComposer : public SymbolBase::visitor_type {
	void Visit(void*, const Symbol& symbol);
	void Visit(void*, const LabeledSymbol& symbol);
	void Visit(void*, const BlankSymbol& symbol);
	void Visit(void*, const BottomOfTheStackSymbol& symbol);
	void Visit(void*, const EndSymbol& symbol);

public:
	/**
	 * Prints text representation of Symbol to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	std::string compose(const Symbol& string);
};

} /* namespace alphabet */

#endif /* SYMBOL_TO_STRING_COMPOSER_H_ */
