/*
 * SymbolToXMLComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "SymbolToXMLComposer.h"

#include "../ToXMLComposers.h"

namespace alphabet {

void SymbolToXMLComposer::Visit(void* userData, const BlankSymbol&) const {
	std::list<sax::Token> &out = *((std::list<sax::Token>*) userData);

	out.push_back(sax::Token("BlankSymbol", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token("BlankSymbol", sax::Token::TokenType::END_ELEMENT));
}

void SymbolToXMLComposer::Visit(void* userData, const BottomOfTheStackSymbol&) const {
	std::list<sax::Token> &out = *((std::list<sax::Token>*) userData);

	out.push_back(sax::Token("BottomOfTheStackSymbol", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token("BottomOfTheStackSymbol", sax::Token::TokenType::END_ELEMENT));
}

void SymbolToXMLComposer::Visit(void* userData, const EndSymbol&) const {
	std::list<sax::Token> &out = *((std::list<sax::Token>*) userData);

	out.push_back(sax::Token("EndSymbol", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token("EndSymbol", sax::Token::TokenType::END_ELEMENT));
}

void SymbolToXMLComposer::Visit(void* userData, const LabeledSymbol& symbol) const {
	std::list<sax::Token> &out = *((std::list<sax::Token>*) userData);

	out.push_back(sax::Token("LabeledSymbol", sax::Token::TokenType::START_ELEMENT));
	out.splice(out.end(), alib::ToXMLComposers::labelComposer.compose(symbol.getLabel()));
	out.push_back(sax::Token("LabeledSymbol", sax::Token::TokenType::END_ELEMENT));
}

void SymbolToXMLComposer::Visit(void* userData, const Symbol& symbol) const {
	symbol.getSymbol().Accept(userData, *this);

}

std::list<sax::Token> SymbolToXMLComposer::compose(const Symbol& symbol) const {
	std::list<sax::Token> out;
	Visit((void*) &out, symbol);
	return out;
}

} /* namespace alphabet */
