/*
 * SymbolToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef SYMBOL_TO_XML_COMPOSER_H_
#define SYMBOL_TO_XML_COMPOSER_H_

#include <list>
#include "Symbol.h"
#include "../sax/Token.h"
#include "../label/Label.h"

namespace alphabet {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class SymbolToXMLComposer : public SymbolBase::const_visitor_type {
	void Visit(void*, const Symbol& symbol) const;
	void Visit(void*, const LabeledSymbol& symbol) const;
	void Visit(void*, const BlankSymbol& symbol) const;
	void Visit(void*, const BottomOfTheStackSymbol& symbol) const;
	void Visit(void*, const EndSymbol& symbol) const;

public:
	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	std::list<sax::Token> compose(const Symbol& symbol) const;
};

} /* namespace alphabet */

#endif /* SYMBOL_TO_XML_COMPOSER_H_ */
