/*
 * State.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Martin Zak
 */

#include "State.h"

namespace automaton {

State::State(const label::Label& name) : name(name) {
}

const label::Label& State::getName() const {
	return name;
}

bool State::operator < (const State& other) const {
	return name < other.name;
}

bool State::operator == (const State& other) const {
	return name == other.name;
}

bool State::operator != (const State& other) const{
	return !(*this == other);
}

std::ostream& operator<<(std::ostream& out, const State& state) {
	out << "(State " << state.name << ")";
	return out;
}

} /* namespace automaton */
