/*
 * AlibException.h
 *
 * Created on: Apr 1, 2013
 * Author: Martin Zak
 */

#ifndef ALIB_EXCEPTION_H_
#define ALIB_EXCEPTION_H_

#include <exception>
#include <string>

namespace exception {

/**
 * Basic exception from which are derived all other exceptions.
 * Contains reason why the exception occured.
 */
class AlibException : public std::exception {
protected:

	std::string cause;
	std::string backtrace;
	std::string whatMessage;
public:

	AlibException ( );
	explicit AlibException ( const std::string & cause );
	virtual ~AlibException ( ) noexcept;

	/**
	 * @return reason why the exception occured
	 */
	const char * what ( ) const noexcept;

	/**
	 * @return reason why the exception occured
	 */
	const std::string & getCause ( ) const;

	/**
	 * @return reason why the exception occured
	 */
	const std::string & getBacktrace ( ) const;
	
};

} /* namespace exception */

#endif /* ALIB_EXCEPTION_H_ */
