/*
 * ExceptionFromXMLParser.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "ExceptionFromXMLParser.h"
#include "../sax/ParserException.h"
#include <string>

namespace exception {

AlibException ExceptionFromXMLParser::parse(std::list<sax::Token>& input) const {
	return parse(input, std::set<FEATURES>({FEATURES::ALIB_EXCEPTION}));
}

AlibException ExceptionFromXMLParser::parse(std::list<sax::Token>& input, const std::set<FEATURES>& features) const {
	if(!features.count(FEATURES::ALIB_EXCEPTION)) throw exception::AlibException();
	popToken(input, sax::Token::TokenType::START_ELEMENT, "exception");
	std::string cause = "";
	if (input.front().getType() == sax::Token::TokenType::CHARACTER) {
		cause = input.front().getData();
		input.pop_front();
	}
	popToken(input, sax::Token::TokenType::END_ELEMENT, "exception");
	return AlibException(cause);
}

bool ExceptionFromXMLParser::first(std::list<sax::Token>& input) const {
	if(isToken(input, sax::Token::TokenType::START_ELEMENT, "exception")) {
		return true;
	} else {
		return false;
	}
}

} /* namespace exception */
