/*
 * ExceptionFromXMLParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef EXCEPTION_FROM_XML_PARSER_H_
#define EXCEPTION_FROM_XML_PARSER_H_

#include <list>
#include "../FromXMLParser.hpp"
#include "ExceptionFeatures.h"
#include "AlibException.h"

namespace exception {

/**
 * Parser used to get String from XML parsed into list of tokens.
 */
class ExceptionFromXMLParser : public alib::FromXMLParser<AlibException, FEATURES> {
	virtual AlibException parse(std::list<sax::Token>& input) const;
	virtual AlibException parse(std::list<sax::Token>& input, const std::set<FEATURES>& features) const;
public:
	virtual bool first(std::list<sax::Token>& input) const;
};

} /* namespace exception */

#endif /* EXCEPTION_FROM_XML_PARSER_H_ */
