/*
 * ExceptionToXMLComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "ExceptionToXMLComposer.h"

namespace exception {

void ExceptionToXMLComposer::Visit(void* userData, const AlibException& exception) const {
	std::list<sax::Token> &out = *((std::list<sax::Token>*) userData);
	
	out.push_back(sax::Token("exception", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token(exception.getCause(), sax::Token::TokenType::CHARACTER));
	out.push_back(sax::Token("exception", sax::Token::TokenType::END_ELEMENT));
}

std::list<sax::Token> ExceptionToXMLComposer::compose(const AlibException& exception) const {
	std::list<sax::Token> out;
	Visit((void*) &out, exception);
	return out;
}

} /* namespace exception */
