/*
 * ExceptionToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef EXCEPTION_TO_XML_COMPOSER_H_
#define EXCEPTION_TO_XML_COMPOSER_H_

#include <list>
#include "AlibException.h"
#include "../sax/Token.h"

namespace exception {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class ExceptionToXMLComposer {
	void Visit(void* userData, const AlibException& exception) const;
public:
	/**
	 * Prints XML representation of AlibException to the output stream.
	 * @param string Exception to print
	 * @param out output stream to which print the String
	 */
	std::list<sax::Token> compose(const AlibException& exception) const;
};

} /* namespace exception */

#endif /* EXCEPTION_TO_XML_COMPOSER_H_ */
