/*
 * Grammar.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef GRAMMAR_H_
#define GRAMMAR_H_

#include "../std/visitor.hpp"
#include "GrammarBase.h"

namespace grammar {

/**
 * Wrapper around automata.
 */
class Grammar {
protected:
	GrammarBase* grammar;
public:
	explicit Grammar(const GrammarBase& grammar);
	explicit Grammar(GrammarBase&& grammar);
	Grammar(const Grammar& other);
	Grammar(Grammar&&) noexcept;
	Grammar& operator=(const Grammar& other);
	Grammar& operator=(Grammar&& other) noexcept;
	virtual ~Grammar() noexcept;

	const GrammarBase& getGrammar() const;
	GrammarBase& getGrammar();

	void setGrammar(const GrammarBase& grammar);
	void setGrammar(GrammarBase&& grammar);
	
	bool operator!=(const Grammar& other) const;

	bool operator==(const Grammar& other) const;

	friend std::ostream& operator<<(std::ostream& os, const Grammar& grammar);
};

} /* namespace grammar */

#endif /* GRAMMAR_H_ */

