/*
 * CharacterLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "CharacterLabel.h"

namespace label {

CharacterLabel::CharacterLabel(char label) : label(label) {

}

LabelBase* CharacterLabel::clone() const {
	return new CharacterLabel(*this);
}

LabelBase* CharacterLabel::plunder() && {
	return new CharacterLabel(std::move(*this));
}

char CharacterLabel::getData() const {
	return label;
}

bool CharacterLabel::operator<(const LabelBase& other) const {
	return other > *this;
}

bool CharacterLabel::operator==(const LabelBase& other) const {
	return other == *this;
}

bool CharacterLabel::operator >(const LabelBase& other) const {
	return other < *this;
}


bool CharacterLabel::operator <(const CharacterLabel& other) const {
	return label < other.label;
}

bool CharacterLabel::operator ==(const CharacterLabel& other) const {
	return label == other.label;
}

void CharacterLabel::operator>>(std::ostream& out) const {
	out << "(CharacterLabel " << label << ")";
}

CharacterLabel::operator std::string() const {
	return std::string(1, label);
}

} /* namespace label */

