/*
 * IntegerLabel.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef INTEGER_LABEL_H_
#define INTEGER_LABEL_H_

#include <ostream>

#include "LabelBase.h"

namespace label {

/**
 * Represents symbol in an alphabet.
 */
class IntegerLabel : public std::element<IntegerLabel, LabelBase> {
protected:
	int label;
public:
	virtual LabelBase* clone() const;

	virtual LabelBase* plunder() &&;

	/**
	 * Creates new symbol with given name.
	 * @param symbol name of the symbol
	 */
	explicit IntegerLabel(int label);

	virtual bool operator<(const LabelBase& other) const;
	
	virtual bool operator>(const LabelBase& other) const;

	virtual bool operator==(const LabelBase& other) const;

	/**
	 * @return name of the symbol
	 */
	int getData() const;

	virtual bool operator <(const IntegerLabel& other) const;
	
	virtual bool operator ==(const IntegerLabel& other) const;
	
	virtual void operator>>(std::ostream&) const;

	virtual operator std::string() const;
};

} /* namespace label */

#endif /* INTEGER_LABEL_H_ */
