/*
 * Label.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_H_
#define LABEL_H_

#include "../std/visitor.hpp"
#include "LabelBase.h"

namespace label {

/**
 * Wrapper around automata.
 */
class Label {
protected:
	LabelBase* label;
public:
	explicit Label(const LabelBase& label);
	explicit Label(LabelBase&& label);
	Label(const Label& other);
	Label(Label&&) noexcept;
	Label& operator=(const Label& other);
	Label& operator=(Label&& other) noexcept;
	virtual ~Label() noexcept;

	const LabelBase& getLabel() const;
	LabelBase& getLabel();

	void setLabel(const LabelBase& label);
	void setLabel(LabelBase&& label);

	bool operator<(const Label& other) const;
	
	bool operator!=(const Label& other) const;

	bool operator==(const Label& other) const;

	friend std::ostream& operator<<(std::ostream& os, const Label& label);

	operator std::string () const;
};

} /* namespace label */

#endif /* LABEL_H_ */

