/*
 * LabelBase.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#include "LabelBase.h"
#include <typeinfo>

#include "StringLabel.h"
#include "IntegerLabel.h"
#include "CharacterLabel.h"

namespace label {

LabelBase::~LabelBase() {

}

bool LabelBase::operator<(const StringLabel& other) const {
	return typeid(*this).before(typeid(other));
}

bool LabelBase::operator<(const IntegerLabel& other) const {
	return typeid(*this).before(typeid(other));
}

bool LabelBase::operator<(const CharacterLabel& other) const {
	return typeid(*this).before(typeid(other));
}

bool LabelBase::operator>=(const LabelBase& other) const {
	return !(*this < other);
}

bool LabelBase::operator<=(const LabelBase& other) const {
	return !(*this > other);
}

bool LabelBase::operator!=(const LabelBase& other) const {
	return !(*this == other);
}

bool LabelBase::operator==(const StringLabel&) const {
	return false;
}

bool LabelBase::operator==(const IntegerLabel&) const {
	return false;
}

bool LabelBase::operator==(const CharacterLabel&) const {
	return false;
}

std::ostream& operator<<(std::ostream& os, const LabelBase& label) {
	label >> os;
	return os;
}

} /* namespace label */

