#ifndef LABEL_FROM_STRING_LEXER_H_
#define LABEL_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>

namespace label {

class LabelFromStringLexer {
public:
	enum class TokenType {
		STRING,
		CHAR,
		INTEGER,
		TEOF,
		ERROR
	};

	struct Token {
	      TokenType type;
	      std::string value;
	};
private:
	std::stringstream& m_In;
	Token m_Current;
public:

	LabelFromStringLexer(std::stringstream&);
	LabelFromStringLexer& next();
	Token token();
};

} /* namespace label */

#endif /* LABEL_FROM_STRING_LEXER_H_ */
