/*
 * LabelFromXMLParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_FROM_XML_PARSER_H_
#define LABEL_FROM_XML_PARSER_H_

#include "../FromXMLParser.hpp"
#include <vector>
#include <set>
#include "Label.h"
#include "LabelFeatures.h"
#include "../sax/Token.h"
#include "../label/Label.h"

namespace alphabet {

class SymbolFromXMLParser;

} /* namespace alphabet */

namespace automaton {

class AutomatonFromXMLParser;

} /* namespace automaton */

namespace label {

/**
 * Parser used to transform sequence of xml tokens to internal representation of Label.
 */
class LabelFromXMLParser : public alib::FromXMLParser<Label, FEATURES> {
	virtual Label parse(std::list<sax::Token>& input, const std::set<FEATURES>&) const;
	
	virtual Label parse(std::list<sax::Token>& input) const;

public:
	virtual bool first(std::list<sax::Token>& input) const;

	friend class alphabet::SymbolFromXMLParser;

	friend class automaton::AutomatonFromXMLParser;
};

} /* namespace label */

#endif /* LABEL_FROM_XML_PARSER_H_ */
