/*
 * LabelToXMLComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "LabelToXMLComposer.h"
#include "IntegerLabel.h"
#include "StringLabel.h"
#include "CharacterLabel.h"
#include "../std/itos.h"

namespace label {

void LabelToXMLComposer::Visit(void* userData, const IntegerLabel& label) const {
	std::list<sax::Token> &out = *((std::list<sax::Token>*) userData);

	out.push_back(sax::Token("IntegerLabel", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token(std::itos(label.getData()), sax::Token::TokenType::CHARACTER));
	out.push_back(sax::Token("IntegerLabel", sax::Token::TokenType::END_ELEMENT));
}

void LabelToXMLComposer::Visit(void* userData, const CharacterLabel& label) const {
	std::list<sax::Token> &out = *((std::list<sax::Token>*) userData);

	out.push_back(sax::Token("CharacterLabel", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token(std::string(1, label.getData()), sax::Token::TokenType::CHARACTER));
	out.push_back(sax::Token("CharacterLabel", sax::Token::TokenType::END_ELEMENT));
}

void LabelToXMLComposer::Visit(void* userData, const StringLabel& label) const {
	std::list<sax::Token> &out = *((std::list<sax::Token>*) userData);

	out.push_back(sax::Token("StringLabel", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token(label.getData(), sax::Token::TokenType::CHARACTER));
	out.push_back(sax::Token("StringLabel", sax::Token::TokenType::END_ELEMENT));
}

void LabelToXMLComposer::Visit(void* userData, const Label& label) const {
	label.getLabel().Accept(userData, *this);

}

std::list<sax::Token> LabelToXMLComposer::compose(const Label& label) const {
	std::list<sax::Token> out;
	Visit((void*) &out, label);
	return out;
}

} /* namespace label */
