/*
 * LabelToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef LABEL_TO_XML_COMPOSER_H_
#define LABEL_TO_XML_COMPOSER_H_

#include <list>
#include "Label.h"
#include "../sax/Token.h"

namespace label {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class LabelToXMLComposer : public LabelBase::const_visitor_type {
	void Visit(void*, const Label& label) const;
	void Visit(void*, const StringLabel& label) const;
	void Visit(void*, const IntegerLabel& label) const;
	void Visit(void*, const CharacterLabel& label) const;

public:
	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	std::list<sax::Token> compose(const Label& label) const;
};

} /* namespace label */

#endif /* LABEL_TO_XML_COMPOSER_H_ */
