/*
 * NextLabel.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "NextLabel.h"
#include "IntegerLabel.h"
#include "StringLabel.h"
#include "CharacterLabel.h"
#include "../std/itos.h"

namespace label {

void NextLabel::Visit(void* userData, const IntegerLabel& label) {
	Label* &out = *((Label**) userData);

	out = new Label(IntegerLabel(label.getData() + 1));
}

void NextLabel::Visit(void* userData, const CharacterLabel& label) {
	Label* &out = *((Label**) userData);

	out = new Label(CharacterLabel(label.getData() + 1));
}

void NextLabel::Visit(void* userData, const StringLabel& label) {
	Label* &out = *((Label**) userData);

	out = new Label(StringLabel(label.getData() + '\''));
}

void NextLabel::Visit(void* userData, const Label& label) {
	label.getLabel().Accept(userData, *this);

}

Label NextLabel::nextLabel(const Label& label) {
	Label* out;
	Visit((void*) &out, label);

	Label nextLabel(std::move(*out));
	delete out;
	return std::move(nextLabel);
}

} /* namespace label */
