/*
 * NextLabel.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef NEXT_LABEL_H_
#define NEXT_LABEL_H_

#include <list>
#include "Label.h"
#include "../sax/Token.h"

namespace label {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class NextLabel : public LabelBase::visitor_type {
	void Visit(void*, const Label& label);
	void Visit(void*, const StringLabel& label);
	void Visit(void*, const IntegerLabel& label);
	void Visit(void*, const CharacterLabel& label);

public:
	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	Label nextLabel(const Label& label);
};

} /* namespace label */

#endif /* NEXT_LABEL_H_ */
