/*
 * RegExpElement.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Martin Zak
 */

#include "RegExpElement.h"
#include <typeinfo>

#include "RegExpElements.h"

namespace regexp {

RegExpElement::RegExpElement() : parentRegExp(NULL) {

}

RegExpElement::~RegExpElement() noexcept {

}

bool RegExpElement::operator>=(const RegExpElement& other) const {
	return !(*this < other);
}

bool RegExpElement::operator<=(const RegExpElement& other) const {
	return !(*this > other);
}

bool RegExpElement::operator!=(const RegExpElement& other) const {
	return !(*this == other);
}


bool RegExpElement::operator<(const Concatenation& other) const {
	return typeid(*this).before(typeid(other));
}

bool RegExpElement::operator<(const Alternation& other) const {
	return typeid(*this).before(typeid(other));
}

bool RegExpElement::operator<(const Iteration& other) const {
	return typeid(*this).before(typeid(other));
}

bool RegExpElement::operator<(const RegExpSymbol& other) const {
	return typeid(*this).before(typeid(other));
}

bool RegExpElement::operator<(const RegExpEpsilon& other) const {
	return typeid(*this).before(typeid(other));
}

bool RegExpElement::operator<(const RegExpEmpty& other) const {
	return typeid(*this).before(typeid(other));
}


bool RegExpElement::operator==(const Concatenation&) const {
	return false;
}

bool RegExpElement::operator==(const Alternation&) const {
	return false;
}

bool RegExpElement::operator==(const Iteration&) const {
	return false;
}

bool RegExpElement::operator==(const RegExpSymbol&) const {
	return false;
}

bool RegExpElement::operator==(const RegExpEpsilon&) const {
	return false;
}

bool RegExpElement::operator==(const RegExpEmpty&) const {
	return false;
}

std::ostream& operator<<(std::ostream& out, const RegExpElement& regexp) {
	regexp >> out;
	return out;
}

} /* namespace regexp */
