/*
 * RegExpEpsilon.cpp
 *
 *  Created on: Jan 30, 2014
 *      Author: Jan Travnicek
 */

#include "RegExpEpsilon.h"

namespace regexp {
  
RegExpEpsilon::RegExpEpsilon() {
  // so that default constructor is available
}
  
RegExpEpsilon::RegExpEpsilon(const RegExpEpsilon&) {
  // so that copy constructor is available
}

RegExpEpsilon::RegExpEpsilon(RegExpEpsilon&&) noexcept {
	this->attachRegExp(NULL);
}

RegExpEpsilon& RegExpEpsilon::operator =(const RegExpEpsilon&) {
  //this is actually different than default implementation
  return *this;
}

RegExpEpsilon& RegExpEpsilon::operator =(RegExpEpsilon&&) noexcept {
  //this is actually different than default implementation
  return *this;
}
  
RegExpElement* RegExpEpsilon::clone() const {
	return new RegExpEpsilon(*this);
}

RegExpElement* RegExpEpsilon::plunder() && {
	return new RegExpEpsilon(std::move(*this));
}

bool RegExpEpsilon::operator<(const RegExpElement& other) const {
	return other > *this;
}

bool RegExpEpsilon::operator==(const RegExpElement& other) const {
	return other == *this;
}

bool RegExpEpsilon::operator>(const RegExpElement& other) const {
	return other < *this;
}


bool RegExpEpsilon::operator<(const RegExpEpsilon&) const {
	  return false;
}

bool RegExpEpsilon::operator==(const RegExpEpsilon&) const {
	  return true;
}

void RegExpEpsilon::operator>>(std::ostream& out) const {
	out << "(RegExpEpsilon)";
}

bool RegExpEpsilon::testSymbol( const alphabet::Symbol & ) const {
	return false;
}

bool RegExpEpsilon::attachRegExp(const RegExp * regexp ) {
	if(this->parentRegExp == regexp) return true;
	this->parentRegExp = regexp;
	return true;
}

void RegExpEpsilon::computeMinimalAlphabet( std::set<alphabet::Symbol>&) const {

}

bool RegExpEpsilon::containsEmptyString() const {
	return true;
}

bool RegExpEpsilon::isEmpty() const {
	return false;
}

} /* namespace regexp */
