#ifndef REG_EXP_FROM_STRING_LEXER_H_
#define REG_EXP_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>

namespace regexp {

class RegExpFromStringLexer {
public:
	enum class TokenType {
	      LPAR,
	      RPAR,
	      PLUS,
	      STAR,
	      EPS,
	      EMPTY,
	      TEOF,
	      ERROR
	};

	struct Token {
	      TokenType type;
	      std::string value;
	};
private:
	std::stringstream& m_In;
	Token m_Current;
public:

	RegExpFromStringLexer(std::stringstream&);
	RegExpFromStringLexer& next();
	Token token();
};

} /* namespace regexp */

#endif /* REG_EXP_FROM_STRING_LEXER_H_ */
