/*
 * RegExpToStringComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef REX_EXP_TO_STRING_COMPOSER_H_
#define REX_EXP_TO_STRING_COMPOSER_H_

#include <string>
#include "RegExp.h"
#include "RegExpElements.h"

namespace regexp {

class RegExpToStringComposer : public RegExpElement::visitor_type {
	void Visit(void*, const Alternation& alternation);
	void Visit(void*, const Concatenation& concatenation);
	void Visit(void*, const Iteration& iteration);
	void Visit(void*, const RegExpSymbol& symbol);
	void Visit(void*, const RegExpEpsilon& epsilon);
	void Visit(void*, const RegExpEmpty& empty);
	
	void Visit(void*, const RegExpElement::element_type& element);
	
	
	void Visit(void*, const RegExp& empty);

	enum class Priority {
		ALTERNATION,
		CONCATENATION,
		FACTOR
	};
public:
	/**
	 * Composes string representation of RegExp.
	 * @param regexp RegExp to print
	 * @returns string representation of regexp
	 */
	std::string compose(const RegExp& regexp);
};

} /* namespace regexp */

#endif /* REX_EXP_TO_STRING_COMPOSER_H_ */
