/*
 * RegExpToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Martin Zak
 */

#ifndef REG_EXP_TO_XML_COMPOSER_H_
#define REG_EXP_TO_XML_COMPOSER_H_

#include "RegExp.h"
#include "RegExpElements.h"
#include "../std/visitor.hpp"
#include "../sax/Token.h"

namespace regexp {

/**
 * This class contains methods to print XML representation of regular expression to the output stream.
 */
class RegExpToXMLComposer : public RegExpElement::const_visitor_type {
	void Visit(void*, const Alternation& alternation) const;
	void Visit(void*, const Concatenation& concatenation) const;
	void Visit(void*, const Iteration& iteration) const;
	void Visit(void*, const RegExpSymbol& symbol) const;
	void Visit(void*, const RegExpEpsilon& epsilon) const;
	void Visit(void*, const RegExpEmpty& empty) const;
	
	void Visit(void*, const RegExpElement::element_type& element) const;
	
	
	void Visit(void*, const RegExp& empty) const;

public:
	/**
	 * Composes XML token representation of RegExp.
	 * @param regexp RegExp to print
	 * @returns list of xml tokens.
	 */
	std::list<sax::Token> compose(const RegExp& regexp) const;
};

} /* namespace regexp */

#endif /* REG_EXP_TO_XML_COMPOSER_H_ */
