/*
 * Epsilon.cpp
 *
 *  Created on: Jan 30, 2014
 *      Author: Jan Travnicek
 */

#include "Epsilon.h"
#include <sstream>

#include "LinearString.h"
#include "CyclicString.h"

namespace string {

Epsilon::Epsilon() {

}

bool Epsilon::testSymbol( const alphabet::Symbol & ) const {
	return false;
}

void Epsilon::computeMinimalAlphabet(std::set<alphabet::Symbol>&) const {

}

StringBase* Epsilon::clone() const {
	return new Epsilon(*this);
}

StringBase* Epsilon::plunder() && {
	return new Epsilon(std::move(*this));
}

bool Epsilon::operator<(const StringBase& other) const {
	return other > *this;
}

bool Epsilon::operator==(const StringBase& other) const {
	return other == *this;
}

bool Epsilon::operator>(const StringBase& other) const {
	return other < *this;
}

std::vector<alphabet::Symbol> Epsilon::getContent() const {
	return {};
}

bool Epsilon::isEmpty() const {
	return true;
}

bool Epsilon::operator<(const Epsilon&) const {
  return false;
}

bool Epsilon::operator<(const LinearString& other) const {
	return LinearString({}) < other;
}

bool Epsilon::operator<(const CyclicString& other) const {
	return CyclicString({}) < other;
}

bool Epsilon::operator==(const Epsilon&) const {
	return true;
}

bool Epsilon::operator==(const LinearString& other) const {
	return LinearString({}) == other;
}

bool Epsilon::operator==(const CyclicString& other) const {
	return CyclicString({}) == other;
}

void Epsilon::operator>>(std::ostream& out) const {
	out << "(Epsilon)";
}

Epsilon::operator std::string() const {
	std::stringstream ss;
	ss << *this;
	return ss.str();
}

Epsilon Epsilon::EPSILON = Epsilon();

} /* namespace string */
