/*
 * StringBase.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "StringBase.h"
#include <typeinfo>

#include "LinearString.h"
#include "CyclicString.h"
#include "Epsilon.h"
#include <algorithm>

namespace string {

StringBase::StringBase() : parentString(NULL) {

}

StringBase::~StringBase() noexcept {

}

bool StringBase::attachString ( const String * string ) {
	if(this->parentString == string) return true;
	this->parentString = string;
	if(string == NULL) return true;
	
	std::set<alphabet::Symbol> minimalAlphabet;
	this->computeMinimalAlphabet(minimalAlphabet);
	std::set<alphabet::Symbol> unavailableSymbols;
	std::set_difference(minimalAlphabet.begin(), minimalAlphabet.end(), this->parentString->getAlphabet().begin(), this->parentString->getAlphabet().end(), std::inserter(unavailableSymbols, unavailableSymbols.end()));

	return unavailableSymbols.empty();
}

bool StringBase::operator !=(const StringBase& other) const {
	return !(*this == other);
}

std::ostream& operator<<(std::ostream& out, const StringBase& string) {
	string >> out;
	return out;
}

} /* namespace string */
