#ifndef STRING_FROM_STRING_LEXER_H_
#define STRING_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>
#include "../label/LabelFromStringLexer.h"

namespace string {

class StringFromStringLexer {
public:
	enum class TokenType {
		LESS,
		GREATER,
		QUOTE,
		EPSILON,
		TEOF,
		ERROR
	};

	struct Token {
	      TokenType type;
	      std::string value;
	};
private:
	std::stringstream& m_In;
	Token m_Current;
public:
  
	StringFromStringLexer(std::stringstream&);
	StringFromStringLexer& next();
	Token token();
};

} /* namespace string */

#endif /* STRING_FROM_STRING_LEXER_H_ */
