/*
 * StringFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_FROM_STRING_PARSER_H_
#define STRING_FROM_STRING_PARSER_H_

#include "String.h"
#include "StringFeatures.h"
#include <vector>
#include "../alphabet/Symbol.h"

#include "StringFromStringLexer.h"
#include "../alphabet/SymbolFromStringParser.h"
#include "../FromStringParser.hpp"

namespace string {

class StringFromStringParser : public alib::FromStringParser<String, FEATURES> {
	std::vector<alphabet::Symbol> parseContent();
	
	StringFromStringLexer m_StringLexer;
	alphabet::SymbolFromStringParser m_SymbolParser;

	virtual String parse();
	virtual String parse(const std::set<FEATURES>& features);
	bool next();
	virtual bool last();
public:
	virtual bool first();
	StringFromStringParser(std::stringstream&);

};

} /* namespace string */

#endif /* STRING_FROM_STRING_PARSER_H_ */
