/*
 * StringToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef STRING_TO_XML_COMPOSER_H_
#define STRING_TO_XML_COMPOSER_H_

#include <list>
#include "String.h"
#include "../sax/Token.h"
#include "../alphabet/Symbol.h"

namespace string {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class StringToXMLComposer : public StringBase::const_visitor_type {
	void Visit(void*, const String& string) const;
	void Visit(void*, const LinearString& string) const;
	void Visit(void*, const CyclicString& string) const;
	void Visit(void*, const Epsilon& string) const;

public:
	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	std::list<sax::Token> compose(const String& string) const;
};

} /* namespace string */

#endif /* STRING_TO_XML_COMPOSER_H_ */
